/*
 * Created on 02/12/2004
 *
 */
package moca.core.proxy.development;


/**
 *  
 * A ConnectionListener object is used to get the connection notification of
 * clients. The @link #onReceiveConnectionNotification(String, boolean) informs
 * the client identification, and its situation - connected or not.
 * 
 * <p>
 * The proxy application may use this information to compute for how long
 * a client is disconnected and then decide, for example, if the client 
 * must not be served anymore (after a timeout period of disconnectio),
 *  and then remove it from the proxy (using @link ProxyFacade#removeClient(String)).
 * 
 * @author hana
 */
public interface ConnectionListener {

	/**
    * The listener method. Its called when the message is received.
    * 
    * @param client  Client identification
    * @param isConnected Client situation, true if connected, false otherwise.  
    */
   abstract public void onReceiveConnectionNotification(String client, boolean isConnected);

}
