package moca.core.proxy.state.filter;

/**
* Classe base para o filtro
* @author hana
*/
public class Filter {
	private BooleanValue bv;
	
	/**
    * Construtor default
	*/
	public Filter() {
	}

	public final boolean accepts(MetaPackage metapack) {
		if (bv == null) {
			return true;
		}
		return bv.getBooleanValue(metapack);
	}
	/**
	 * Construtor que recebe uma expressao booleana
	 * @param bv expressao booleana
	 */
	public Filter(BooleanValue bv) {
		this.bv = bv;
	}
	/**
	 * Converte a expressao para uma string
	 * @return expressao na forma de string
	 */
	public String toString() {
		if (bv == null) {
			return "";
		}
		return bv.toString();
	}

}
