package moca.core.proxy.state.filter;

/**
 * Literal  utilizado para armazenar uma string fixa fornecido diretamente
 * pelo usuario configurador do filtro. 
 * 
 * @author hana
 */
public class LiteralOperator extends UnaryOperator implements StringValue {
	private String value;
	public LiteralOperator(String value) {
		super(null);
		this.value = value;
	}
	/**
	* Valora o operador
	* @param pack meta pack
	* @return valor 
	*/
	public Object evaluate(MetaPackage pack) {
		return this.value;
	}
	/**
	* Retorna o valor como string de acordo com a interface StringValue
	*/
	public String getStringValue(MetaPackage pack) {
		return (String) this.evaluate(pack);
	}
	/**
	 * Converte a expressao para uma string
	 * @return expressao na forma de string
	 */
	public String toString() {
		return "\"" + this.value + "\"";
	}


}
