package moca.core.proxy.state.filter;

/**
 * Operador lgico de negao. Nega o operando booleano
 * @author hana
 */
public class NotOperator extends UnaryOperator implements BooleanValue {
	/**
	 * Construtor que recebe um valor booleano
	 * @param val valor booleano
	 */
	public NotOperator(BooleanValue val) {
		super(val);
	}
	/**
	 * Valora 
	 */
	public Object evaluate(MetaPackage pack) {
		boolean b = ((BooleanValue) val).getBooleanValue(pack);
		return new Boolean(!b);
	}
	/**
	 * Valora segundo a interface BooleanValue
	 */
	public boolean getBooleanValue(MetaPackage metapack) {
		Boolean b = (Boolean) this.evaluate(metapack);
		return b.booleanValue();
	}
	/**
	 * Converte a expressao para uma string
	 * @return expressao na forma de string
	 */
	public String toString() {
		return "(Not(" + this.val + "))";
	}

}
