package moca.core.proxy.state.filter;
/**
 * Operador OR. Executa a operao de ou lgico dos operandos
 * @author hana
 */
public class OrOperator extends BinaryOperator implements BooleanValue {
	/**
	 * Construtor que recebe dois operandos lgicos
	 * @param bv1 operando 1
	 * @param bv2 operando 2
	 */
	public OrOperator(BooleanValue bv1, BooleanValue bv2) {
		super(bv1, bv2);
	}
	/**
	 * Valora. Executa a operao or entre os operandos
	 * @param metapack
	 * @return value
	 */
	public Object evaluate(MetaPackage metapack) {
		boolean b1 = ((BooleanValue) this.val1).getBooleanValue(metapack);
		boolean b2 = ((BooleanValue) this.val2).getBooleanValue(metapack);
		return new Boolean(b1 || b2);
	}
	/**
	* valora o operador segundo a interface BooleanValue
	* @param metapack
	* @return value
	*/
	public boolean getBooleanValue(MetaPackage metapack) {
		Boolean b = (Boolean) this.evaluate(metapack);
		return b.booleanValue();
	}
	/**
	 * Converte a expressao para uma string
	 * @return expressao na forma de string
	 */
	public String toString() {
		return "(" + this.val1 + " or " + this.val2 + ")";
	}

}
